<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_product_typeKarma extends JPlugin
{
	function plgJoomsuite_product_typeKarma( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'karma') return;
		$out = '<input type="text" name="pparams['.$obj->id.'][karma][]" value="'.(isset($obj->karma) ? $obj->karma : '').'">';
		$pt_file = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'community.php';
		if(!file_exists($pt_file))
		{
			$out .= 'This feature will work only if 
			<a href="http://www.mightyextensions.com/joomla-components/peopletouch-community-social-network-service" target="_blank">Mighty Touch</a> is installed';
		}
		echo $out;
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'karma') return;
		if(!$value) return;
		$pt_file = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'community.php';
		if(!file_exists($pt_file)) return;

		$db = &JFactory::getDBO();
		$value = $db->getEscaped(trim($value));
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;
	
		if($type != 'karma') return;
		if(!$field) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		
		$pt_file = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'community.php';
		if(file_exists($pt_file) && $params->get('show_karma'))
		{
			$val = explode('=', $field->value);
			if(isset($val[1]) && $val[1] != '')
			$out =  str_replace('[AMOUNT]', $val[1], JText::_('Purchasing this product your karma will be increased by [AMOUNT] points'));
		}
	}


	function onTypeFormRender()
	{

	}

	function onBeforeCartStore()
	{

	}

	function onAfterSuccessOrder($type, $order_id, $product_id, $field_id, $value, $user_id, $amount)
	{
		if($type != 'karma') return;
		if($value == '') return;

		$pt_file = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php';
		if(file_exists($pt_file))
		{
			$db = & Jfactory::getDBO();
			$val = explode("=", $value);
			if(isset($val[1]))
			{
				require_once $pt_file;
				if(class_exists('JSCommunityApi')) $capi = new JSCommunityApi(); else $capi = new stdClass();
				if(method_exists($capi, 'increaseKarma')) $capi->increaseKarma($user_id, ($val[1] * $amount));
			}
		}
	}

	function onOrderHistoryPrint($type, $order_id, $product_id, $value, $final_status, $user_id, $params)
	{
		if($type != 'karma') return;
		if($value == '') return;

		$out = '';
		$val = explode('=', $value);
		$params = new JParameter($params);
		if($params->get('show_karma') && isset($val[1]) && $val[1] != '')
		{
			$out = ($final_status) ? str_replace('[AMOUNT]', $val[1], JText::_('Your karma was increased by [AMOUNT] points')) 
								: str_replace('[AMOUNT]', $val[1], JText::_('After the product is delivered your karma will be increased by [AMOUNT] points')); 
		}
		return $out;
	}


}
?>